﻿using ModuleTools.Attributes;
using ModuleTools.Interfaces;
using System;
using System.Runtime.Serialization;

namespace DatabaseCore.Models.Department
{
	/// <summary>
	/// Класс, описывающий связь сотрудника и должность в системе
	/// </summary>
	[DataContract]
	[EntityDescription("EmployeeEmployeePost", "Связь сотрудника и должность в системе")]
	[EntityDependency("EmployeePost", "EmployeePostId", "К какой должности относится сотрудник")]
	[EntityDependency("Employee", "EmployeeId", "К какой должности относится сотрудник")]
	public class EmployeeEmployeePost : BaseEntity, IEntitySecurityExtenstion<EmployeeEmployeePost>
	{
		[DataMember]
		[MapConfiguration("EmployeeId")]
		public Guid EmployeeId { get; set; }

		[DataMember]
		[MapConfiguration("EmployeePostId")]
		public Guid EmployeePostId { get; set; }

		[DataMember]
		[MapConfiguration("Rate")]
		public decimal Rate { get; set; }

		[DataMember]
		[MapConfiguration("IsInternalCombination")]
		public bool IsInternalCombination { get; set; }

		[DataMember]
		[MapConfiguration("IsExternalCombination")]
		public bool IsExternalCombination { get; set; }

		//-------------------------------------------------------------------------

		public virtual EmployeePost EmployeePost { get; set; }

		public virtual Employee Employee { get; set; }

		//-------------------------------------------------------------------------

		//-------------------------------------------------------------------------

		public EmployeeEmployeePost SecurityCheck(EmployeeEmployeePost entity, bool allowFullData) => entity;
	}
}
