﻿using ModuleTools.Attributes;
using ModuleTools.Interfaces;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using System.Runtime.Serialization;

namespace DatabaseCore.Models.Department
{
	/// <summary>
	/// Класс, описывающий должность сотрудника в системе
	/// </summary>
	[DataContract]
	[EntityDescription("EmployeePost", "Должность сотрудника в системе")]
	public class EmployeePost : BaseEntity, IEntitySecurityExtenstion<EmployeePost>
	{
		[DataMember]
		[MapConfiguration("EmployeePostName")]
		public string EmployeePostName { get; set; }


		[DataMember]
		[MapConfiguration("Order")]
		public int Order { get; set; }

		//-------------------------------------------------------------------------

		//-------------------------------------------------------------------------

		[ForeignKey("EmployeePostId")]
		public virtual List<EmployeeEmployeePost> EmployeeEmployeePosts { get; set; }

		//-------------------------------------------------------------------------

		public EmployeePost SecurityCheck(EmployeePost entity, bool allowFullData) => entity;
	}
}