﻿using DepartmentBusinessLogic.BindingModels;
using DepartmentBusinessLogic.BusinessLogics;
using DepartmentBusinessLogic.ViewModels;
using DesktopTools.Controls;
using DesktopTools.Enums;
using DesktopTools.Interfaces;
using DesktopTools.Models;
using ModuleTools.Enums;
using System;
using System.Collections.Generic;

namespace DepartmentWindowsDesktop.EntityControls
{
	public partial class ControlEmployeeList :
		GenericControlEntityList<EmployeeGetBindingModel, EmployeeSetBindingModel, EmployeeListViewModel, EmployeeViewModel, EmployeeBusinessLogic>,
		IGenericControlEntityList<EmployeeListViewModel, EmployeeViewModel>
	{
		public ControlEmployeeList()
		{
			InitializeComponent();
			Title = "Сотрудники";
			ControlId = new Guid("22806450-62ad-479f-8ee7-dc1d9a90b6cf");
			AccessOperation = AccessOperation.Сотрудники;
			ControlViewEntityElement = new ControlEmployeeElement();
			_genericControlViewEntityList = this;
		}

		public IControl GetInstanceGenericControl() => new ControlEmployeeList() { ControlId = Guid.NewGuid() };

		public ControlViewEntityListConfiguration GetConfigControl() => new()
		{
			PaginationOn = false,
			HideToolStripButton = new List<ToolStripButtonListNames>
			{
				ToolStripButtonListNames.toolStripButtonSearch
			}
		};

		public EmployeeListViewModel GetDataForControl() => _businessLogic.GetList(new EmployeeGetBindingModel());

		public EmployeeListViewModel GetDataFromParentForControl(Guid id) => throw new NotImplementedException();

		public EmployeeListViewModel GetDataWithPageNameForControl(string key) => throw new NotImplementedException();

		public EmployeeListViewModel GetDataWithPageNumberForControl(int page, int count) => throw new NotImplementedException();
	}
}