﻿using DepartmentBusinessLogic.BindingModels;
using DepartmentBusinessLogic.BusinessLogics;
using DepartmentBusinessLogic.ViewModels;
using DesktopTools.Controls;
using DesktopTools.Enums;
using DesktopTools.Interfaces;
using DesktopTools.Models;
using ModuleTools.Enums;
using System;
using System.Collections.Generic;

namespace DepartmentWindowsDesktop.EntityControls
{
	/// <summary>
	/// Реализация контрола для списка сотрудников должности
	/// </summary>
	public partial class ControlEmployeePostEmployeeList :
		GenericControlEntityList<EmployeeEmployeePostGetBindingModel, EmployeeEmployeePostSetBindingModel, EmployeeEmployeePostListViewModel, EmployeeEmployeePostViewModel, EmployeeEmployeePostBusinessLogic>,
		IGenericControlEntityList<EmployeeEmployeePostListViewModel, EmployeeEmployeePostViewModel>
	{
		public ControlEmployeePostEmployeeList()
		{
			InitializeComponent();
			Title = "Связи сотрудников с должностями";
			ControlId = new Guid("59a917ee-7366-4c97-8a56-42eb86cff99c");
			AccessOperation = AccessOperation.Сотрудники;
			ControlViewEntityElement = new ControlEmployeeEmployeePostElement();
			_genericControlViewEntityList = this;
		}

		public IControl GetInstanceGenericControl() => new ControlEmployeePostEmployeeList() { ControlId = Guid.NewGuid() };

		public ControlViewEntityListConfiguration GetConfigControl() => new()
		{
			PaginationOn = false,
			HideToolStripButton = new List<ToolStripButtonListNames>
			{
				ToolStripButtonListNames.toolStripButtonUpd,
				ToolStripButtonListNames.toolStripButtonSearch
			}
		};

		public EmployeeEmployeePostListViewModel GetDataForControl() => throw new NotImplementedException();

		public EmployeeEmployeePostListViewModel GetDataFromParentForControl(Guid id) => _businessLogic.GetList(new EmployeeEmployeePostGetBindingModel { EmployeePostId = id });

		public EmployeeEmployeePostListViewModel GetDataWithPageNameForControl(string key) => throw new NotImplementedException();

		public EmployeeEmployeePostListViewModel GetDataWithPageNumberForControl(int page, int count) => throw new NotImplementedException();
	}
}