﻿using DepartmentBusinessLogic.BindingModels;
using DepartmentBusinessLogic.BusinessLogics;
using DepartmentBusinessLogic.ViewModels;
using DesktopTools.Controls;
using DesktopTools.Enums;
using DesktopTools.Interfaces;
using DesktopTools.Models;
using ModuleTools.Enums;
using System;
using System.Collections.Generic;

namespace DepartmentWindowsDesktop.EntityControls
{
	/// <summary>
	/// Реализация контрола для списка должностей сотрудников
	/// </summary>
	public partial class ControlEmployeePostList :
		GenericControlEntityList<EmployeePostGetBindingModel, EmployeePostSetBindingModel, EmployeePostListViewModel, EmployeePostViewModel, EmployeePostBusinessLogic>,
		IGenericControlEntityList<EmployeePostListViewModel, EmployeePostViewModel>
	{
		public ControlEmployeePostList()
		{
			InitializeComponent();
			Title = "Должности сотрудников";
			ControlId = new Guid("643f2ec7-9e77-4b8a-8074-5a7915fa16c0");
			AccessOperation = AccessOperation.Сотрудники;
			ControlViewEntityElement = new ControlEmployeePostElement();
			_genericControlViewEntityList = this;
		}

		public IControl GetInstanceGenericControl() => new ControlEmployeePostList() { ControlId = Guid.NewGuid() };

		public ControlViewEntityListConfiguration GetConfigControl() => new()
		{
			PaginationOn = false,
			HideToolStripButton = new List<ToolStripButtonListNames>
			{
				ToolStripButtonListNames.toolStripButtonSearch
			}
		};

		public EmployeePostListViewModel GetDataForControl() => _businessLogic.GetList(new EmployeePostGetBindingModel());

		public EmployeePostListViewModel GetDataFromParentForControl(Guid id) => throw new NotImplementedException();

		public EmployeePostListViewModel GetDataWithPageNameForControl(string key) => throw new NotImplementedException();

		public EmployeePostListViewModel GetDataWithPageNumberForControl(int page, int count) => throw new NotImplementedException();
	}
}